/* 
 *    tpuart -- A TP-UART driver 
 *
 *
 *    File: rxstm.h -- defines for receive state machine
 *
 *    $Id: rxstm.h,v 1.2 2001/05/23 11:33:49 rst Exp $
 *
 *
 *    Copyright (C) 2000 Raffael Stocker <raffael.stocker@stud.fh-deggendorf.de> 
 *                       University of applied sciences Deggendorf
 *
 *    July 2004   Porting driver to kernel 2.6
 *                Reinhold Buchinger <e0125124@student.tuwien.ac.at>
 *                University of Technology Vienna
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of the
 *    License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *    General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place--Suite 330, Boston, MA
 *    02111-1307, USA.
 *
 *
 *    02-Aug-2000: 0.01  Started Coding
 *
 *    Last change:
 *
 *    $Date: 2001/05/23 11:33:49 $ $Author: rst $
 *
 *    $Date: 2004/07/23 08:00:00 $ $Author: rb  $
 */ 

#ifndef __RXSTM
#define __RXSTM

/*
 * State definitions
 */
enum {RX_CTRL, RX_SOURCE_HIGH, RX_SOURCE_LOW, RX_DEST_HIGH,
      RX_DEST_LOW, RX_NPCI, RX_TPCI, RX_DATA, RX_CHKSUM,
      RX_POLL_CHKSUM, RX_POLL_DATA, NR_STATES}; /* <-- NR_STATES must be last! */

#endif /* __RXSTM */

